//!
//!
use crate::repositories::member::models::Member as _Member;
use diesel::deserialize::QueryableByName;

///
#[derive(Eq, Hash, PartialEq, Debug, Clone)]
pub struct MemberReferrerModel {
  ///
  pub id: uuid::Uuid,
  ///
  pub member: _Member,
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
  ///
  pub created_at: i64,
  ///
  pub updated_at: i64,
}

impl QueryableByName<diesel::pg::Pg> for MemberReferrerModel {
  fn build<R: diesel::row::NamedRow<diesel::pg::Pg>>(row: &R) -> diesel::deserialize::Result<Self> {
    let member = _Member {
      id: row.get("_m_id")?,
      site_id: row.get("_m_site_id")?,
      member_class_id: row.get("_m_member_class_id")?,
      member_level_id: row.get("_m_member_level_id")?,
      username: row.get("_m_username")?,
      password: row.get("_m_password")?,
      nickname: row.get("_m_nickname")?,
      mobile_phone_number: row.get("_m_mobile_phone_number")?,
      state: row.get("_m_state")?,
      state_changed_at: row.get("_m_state_changed_at")?,
      parent_member_id: row.get("_m_parent_member_id")?,
      child_member_count: row.get("_m_child_member_count")?,
      last_signined_ip: row.get("_m_last_signined_ip")?,
      last_signined_at: row.get("_m_last_signined_at")?,
      created_at: row.get("_m_created_at")?,
      updated_at: row.get("_m_updated_at")?,
      deleted_at: row.get("_m_deleted_at")?,
    };

    Ok(MemberReferrerModel {
      id: row.get("mr_id")?,
      member,
      can_use: row.get("mr_can_use")?,
      memo: row.get("mr_memo")?,
      created_at: row.get("mr_created_at")?,
      updated_at: row.get("mr_updated_at")?,
    })
  }
}
