use super::schema::member_referrers;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, Debug, Clone)]
#[table_name = "member_referrers"]
pub struct MemberReferrer {
  ///
  pub id: uuid::Uuid,
  ///
  pub member_id: uuid::Uuid,
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
  ///
  pub created_at: i64,
  ///
  pub updated_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "member_referrers"]
pub struct NewMemberReferrer {
  ///
  pub member_id: uuid::Uuid,
}

///
#[derive(AsChangeset, Debug, Clone)]
#[table_name = "member_referrers"]
pub struct ModifyMemberReferrer {
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub member_id: Option<uuid::Uuid>,
  ///
  pub can_use: Option<bool>,
  ///
  pub memo_like: Option<String>,
}

///
#[derive(Debug, Clone)]
pub struct FindAll {
  ///
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::models::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::models::pagination::Sort>>,
}
